#include <mgButton.h>
#include <mgPot.h>
#include <Joystick.h>
#include <mgLed.h>
#include <EEPROM.h>
#include <mgVirtualButton.h>


/*EDIT*/mgButton menu_button(2, 5, 2000);//la butoanele instantze ale clasei mgButton - (a, b, c): a este pinul de semnal, b este
                                         //intervalul de timp in milisecunde luat in considerare pentru stabilirea starii de stabilitate a butonului
                                         //(pt debouncing), c este intervalul minim de timp in milisecunde pentru a se considera ca o apasare este 
                                         //de lunga durata
/*EDIT*/mgButton gear_model_button(4, 5, 2000);//butonul folosit la alternarea intre cele doua metode implementate pentru schimbarea vitezei
                                     //la apasare determina trecerea de la o metoda la cealalta
/*EDIT*/mgButton rear_gear_button(8, 5, 5000);//butonul din schimbatorul Logitech care, daca este apasat cind se intra in viteza a VI-a, 
                                    //determina lansarea comenzii de intrare in marsarier

/*EDIT*/mgButton seq_h_selector(5, 5, 5000);//butonul cu doua pozitii, cu retinere, care selecteaza intre configuratia de schimbator de viteze secvential
                                  //si cea de schimbator de viteze H                                      
/*EDIT*/mgVirtualButton DIN_connector(12, 500, 4, 2);//butonul virtual indicator al starii conectorului la care se conecteaza cablul venit 
                                            //de la schimbatorul de viteze; arata daca mufa de la schimbator este conectata la adaptorul USB
/*EDIT*/mgButton gear_down_button(18, 3, 5000);//butonul de schimbare a vitezei in treapta inferioara in modul Seq
/*EDIT*/mgButton gear_up_button(19, 3, 5000);//butonul de schimbare a vitezei in treapta superioara in modul Seq
                                                                       
/*EDIT*/mgPot x_axis_pot(A0);
/*EDIT*/mgPot y_axis_pot(A1);
/*EDIT*/mgLed menu_led(7);
/*EDIT*/mgLed gear_model_led(9);

//zona de constante configurabile:
/*EDIT*/int gear_sensitivity_array[] = {9, 12, 15, 18, 21, 24};//tabloul valorilor de sensibilitate a schimbarii de viteze
/*EDIT*/int gear_sensitivity = 0;//pozitia sensibilitatii curente in tabloul de sensibilitate a schimbarii de viteze

/*EDIT*/int gear_button_release_delay = 10;//intervalul de timp in milisec intre joystick button press si joystick button release, la schimbarea treptei de viteza,
                                  //in situatia in care hold_button_for_gear = false

/*EDIT*/bool hold_button_for_gear = true;//metoda folosita pentru schimbarea vitezei - prin impulsuri scurte de buton de joystick sau prin apasari prelungi
                                  //care dureaza atita timp cit schimbatorul este in viteza (in acest caz simulatorul auto comanda el automat 
                                  //intrarea in pozitia neutra virtuala, la iesirea din viteza, fara a fi necesara comanda fizica de apasare a butonului de neutru)
int eeprom_hold_button_for_gear = 1;//valoarea stocata in EEPROM care arata starea variabilei hold_button_for_gear;
                                    //daca hold_button_for_gear == true, este 1, daca hold_button_for_gear == false este 0

bool calibration_on = false; //daca este in timpul calibrarii (true) sau nu (false)

/*calibration_state:
false - asteapta confirmarea pozitiei curente a schimbatorului de viteze prin apasarea butonului
true - calibrarea pozitiei a fost confirmata prin apasarea butonului, dar maneta schimbatorului inca se afla in pozitia confirmata
 */
bool calibration_state = false;
int calibration_current_gear = 1; //valorile pentru treapta curenta de viteza in timpul calibrarii sint de la 1 la 6
int current_gear = 0; //valorile pentru treapta de viteza curenta in timpul functionarii normale a schimbatorului; 0 = N; 1-6; 7 = R

int calibration_x_values_array[] = {-1,-1,-1,-1,-1,-1};//coordonata x a pozitiei treptei de viteza calibrate
int calibration_y_values_array[] = {-1,-1,-1,-1,-1,-1};//coordonata y a pozitiei treptei de viteza calibrate

int x_34 = -1;//pozitia palierului de viteze 3 si 4; se calculeaza ca o medie intre x3 si x4
//limitele stinga si dreapta ale palierului de viteze 3-4:
/*EDIT*/int x_delta_left = 140;//distanta pina la limita stinga a palierului de viteze 3-4
/*EDIT*/int x_delta_right= 150;//distanta pina la limita dreapta a palierului de viteze 3-4

int x_12 = -1;//idem, pentru x1 si x2
int x_56 = -1;//idem, pentru x5 si x6
 
/*EDIT*/int current_x_position = 2;//palierul curent de viteze pe care se afla schimbatorul pe axa X; 1 este pe palierul 1-2, 2 pe palierul 3-4, 3 pe palierul 5-6

int y_1 = -1;
int y_2 = -1;
int delta_y_12 = 0;//distanta(/diferenta) dintre pozitiile y_1 si y_2
int y_3 = -1;
int y_4 = -1;
int delta_y_34 = 0;
int y_5 = -1;
int y_6 = -1;
int delta_y_56 = 0;
int delta_gear_y_12 = 0;//distanta fata de pozitia de calibrare y_1 sau y_2 la care se activeaza intrarea in treapta de viteza corespunzatoare
int delta_gear_y_34 = 0;
int delta_gear_y_56 = 0;
/*EDIT*/int delta_gear_change = 124;//media aritmetica a delta_gear_y_**; este distanta fata de pozitiile de calibrare y_* la care se schimba viteza
                            //valoarea de initializare de 124 este pusa pentru a putea opri blink-ul atunci cind confirmi pozitia de calibrare curenta
                            //daca pui 0, blinkul continua chiar daca tu confirmi pozitia curenta de calibrare prin apasarea butonului
                            //valoarea normala este, de fapt, in jur de 248, dar am pus o val mai mica pt verificari

int delta_to_high_gear = 0;//distanta de la pozitia curenta a schimbatorului fata de viteza superioara de pe culoarul x actual
int delta_to_low_gear = 0;//distanta de la pozitia curenta a schimbatorului fata de viteza inferioara de pe culoarul x actual

bool read_from_eeprom = true;//daca este true inseamna ca s-a dat comanda de citire din EEPROM
bool initialize_from_eeprom = false;//daca true initializeaza variabilele necesare pornind de la ceea ce s-a citit din EEPROM

bool check_sensitivity_led = true;//la pornirea arduino este true ca sa determine verificarea valorii gear_sensitivity si daca e 0 aprinde ledul

int delta_gear_x;//este distanta pe X de la pozitia curenta a stickului schimbatorului de viteze pina la pozitia x_34;

bool gear_shifter_disconnected = true;//daca schimbatorul de viteze este deconectat de la adaptorul USB
bool new_gear_shifter_disconnected = true;

bool h_shifter_on = true;//este true daca butonul de selectie intre schimbatorul secvential si cel H este pe pozitia H; false dace e pe secvential
//bool seq_h_selector_button_state = true;//este true daca butonul este in pozitia apasat - corespunzatoare schimbatorului H
//bool new_seq_h_selector_button_state = true;//este valoarea citita in fiecare nou ciclu a pozitiei butonului selector Seq/H


bool sys_start = true;//este true la pornirea sistemului si devine false in primul ciclu al sistemului
                      //permite rularea de cod strict in primul ciclu de la pornirea sistemului
int x_neutral = -1;//pozitia pe X  a stickului la pornirea sistemului - este recomandata pornirea sistemului cu stickul in pozitia neutra centrala
int i_sys_start = 0;//for iterated sys start routines
/*EDIT*/ int n_sys_start_iterations = 40;//the number of sys start iterations necessary to initialize the iterated sys routines


/*EDIT*/int seq_gear_sensitivity_array[] = {45, 30, 15};//tabloul valorilor de sensibilitate a schimbarii de viteze in modul secvential, pe un Logitech DFS
                                                        //reprezinta valori ale procentajului din x_neutral pe care daca stickul il parcurge pe X se declanseaza
                                                        //comanda de gear up sau de gear down la functionarea in mod secvential, pe un Logitech DFS
/*EDIT*/int logitech_dfs_seq_amplitude_percentage = 2;//pozitia din seq_gear_sensitivity_array[] folosita curent la calculul pozitiei stickului
                                                       //la care se produce comanda de gear up sau de gear down
int delta_gear_to_neutral = -1;//distanta de la pozitia neutra a stickului la limita de schimbare a vitezei
                                                                                  //cu Logitech DFS in mod secvential
bool logitech_dfs_seq_gear_up = false;//daca stickul se afla in zona de gear up este true; Logitech DFS in mod secvential
bool logitech_dfs_seq_gear_down = false;//daca stickul se afla in zona de gear down este true; Logitech DFS in mod secvential
/*EDIT*/bool logitech_dfs_seq_updown = true;//una din cele doua posibilitati de configurare a up si down gear
int x_position = 0;

bool sys_refresh = false;

int mem_size_h_var = 0;



int current_seq_state = 0;//configuratia selectata curent pentru pozitia Seq a comutatorului intre Seq si H
                          //posibilitatile de configurare ale adaptorului pentru pozitia Seq a comutatorului intre Seq si H:
                            //0 - schimbator secvential pe Logitech DFS
                            //1 - frina de mina pe Logitech DFS
                            //2 - schimbator secvential generic


bool handbrake_calibration_on = false;//daca secventa de calibrare a frinei de mina este initiata (true)
                                      //daca secventa de calibrare a frinei de mina nu este initiata (false)
int low_handbrake_limit = -1;//pozitia limita la care maneta schimbatorului poate ajunge pe directia catre palierul 1_2
int high_handbrake_limit = -1;//pozitia limita la care maneta schimbatorului poate ajunge pe directia catre palierul 5_6
/*EDIT*/int handbrake_deadzone_percentage = 10;//procentajul din distanta intre pozitia neutra si low_handbrake_limit, respectiv high_handbrake_limit
                            //ce defineste marimea distantei de la pozitia neutra pe care nu se transmite miscarea manetei;
                            //daca distanta intre neutru si low_handbrake_limit este diferita de distanta intre neutru si high_handbrake_limit
                            //atunci si deadzone-ul dinspre low va fi diferit de deadzone-ul dinspre high
int low_handbrake_deadzone = -1;//valoarea reala a dimensiunii zonei de deadzone dinspre low_handbrake_limit
int high_handbrake_deadzone = -1;//valoarea reala a dimensiunii zonei de deadzone dinspre high_handbrake_limit
long handbrake_axis_value = 0;//valoarea transmisa de adaptor catre PC pe calea functiilor bibliotecii joystick
                              //reprezinta valoarea momentana a pozitiei manetei pe axa de joystick aleasa pentru handbrake (rudder)


//int var_test = -1;

void setup() {

pinMode(7, OUTPUT);
pinMode(13, OUTPUT);
Joystick.begin();
//Serial.begin(9600);

}

void loop() {

seq_h_selector.refreshState();

//initializare la startul/resetul sistemului:
if(gear_shifter_disconnected == false && sys_start == true)
{
  x_axis_pot.refreshPotState();
  i_sys_start = i_sys_start + 1;
  
  if(i_sys_start == n_sys_start_iterations)
  {
    sys_start = false;
    i_sys_start = 0;    

    x_neutral = x_axis_pot.returnPotValue();
    
    if(seq_h_selector.on())
    {
      h_shifter_on = true;
    }
      else
      {
        h_shifter_on = false;
      }

    read_from_eeprom = true;
    sys_refresh = true;
  }
}



//citirea memoriei EEPROM:
if(read_from_eeprom == true)
{
  read_from_eeprom = false;
  //citeste din eeprom si initializeaza valorile neconstante de baza:
  EEPROM.get(0, gear_sensitivity);
  EEPROM.get(sizeof(gear_sensitivity), calibration_x_values_array);
  EEPROM.get(sizeof(gear_sensitivity) + sizeof(calibration_x_values_array), calibration_y_values_array);
  EEPROM.get(sizeof(gear_sensitivity) + sizeof(calibration_x_values_array) + sizeof(calibration_y_values_array), eeprom_hold_button_for_gear);
  mem_size_h_var = sizeof(gear_sensitivity) + sizeof(calibration_x_values_array) + sizeof(calibration_y_values_array)
                      + sizeof(eeprom_hold_button_for_gear);
  EEPROM.get(mem_size_h_var, current_seq_state);
  EEPROM.get(mem_size_h_var + sizeof(current_seq_state), logitech_dfs_seq_amplitude_percentage);
  EEPROM.get(mem_size_h_var + sizeof(current_seq_state) + sizeof(logitech_dfs_seq_amplitude_percentage), logitech_dfs_seq_updown);

  EEPROM.get(mem_size_h_var + sizeof(current_seq_state) + sizeof(logitech_dfs_seq_amplitude_percentage) + sizeof(logitech_dfs_seq_updown), low_handbrake_limit);
  EEPROM.get(mem_size_h_var + sizeof(current_seq_state) + sizeof(logitech_dfs_seq_amplitude_percentage) + sizeof(logitech_dfs_seq_updown)
                    + sizeof(low_handbrake_limit), high_handbrake_limit);  

  if(calibration_x_values_array[0] != -1)
  {
    initialize_from_eeprom = true;
  }
    else//daca la pornire constata ca are stocata valoarea -1, inseamna ca e la prima pornire si trebuie sa initieze calibrarea schimbatorului
    {
      calibration_on = true;
      calibration_state = true;
      menu_led.blinkOn(250);
      //menu_led.blinkBeat();      
    }
}

//initializarea variabilelor sistem folosind valorile citite in EEPROM
if(initialize_from_eeprom == true)
{
  initialize_from_eeprom = false;

  delta_gear_to_neutral = (x_neutral * seq_gear_sensitivity_array[logitech_dfs_seq_amplitude_percentage]) / 100;

  switch(eeprom_hold_button_for_gear)
  {
    case 0:
      hold_button_for_gear = false;
      //gear_model_led.lightOn();
      break;

    case 1:
      hold_button_for_gear = true;
      //gear_model_led.lightOff();
      break;
  }
  
  //valorile folosite in functionarea normala a schimbatorului de viteze:
  x_12 = (calibration_x_values_array[0] + calibration_x_values_array[1]) / 2;
  x_34 = (calibration_x_values_array[2] + calibration_x_values_array[3]) / 2;
  x_56 = (calibration_x_values_array[4] + calibration_x_values_array[5]) / 2;

  if(low_handbrake_limit < 0)
  {
    low_handbrake_limit = x_12;
    high_handbrake_limit = x_56;
  }
  low_handbrake_deadzone = (x_neutral - low_handbrake_limit) * handbrake_deadzone_percentage / 100;
  high_handbrake_deadzone = (high_handbrake_limit - x_neutral) * handbrake_deadzone_percentage / 100;
  

  y_1 = calibration_y_values_array[0];
  y_2 = calibration_y_values_array[1];
  delta_y_12 = y_1 - y_2;
  delta_y_12 = abs(delta_y_12);
  delta_gear_y_12 = (delta_y_12 / 100) * gear_sensitivity_array[gear_sensitivity];

  y_3 = calibration_y_values_array[2];
  y_4 = calibration_y_values_array[3];
  delta_y_34 = y_3 - y_4;
  delta_y_34 = abs(delta_y_34);
  delta_gear_y_34 = (delta_y_34 / 100) * gear_sensitivity_array[gear_sensitivity];

  y_5 = calibration_y_values_array[4];
  y_6 = calibration_y_values_array[5];
  delta_y_56 = y_5 - y_6;
  delta_y_56 = abs(delta_y_56);
  delta_gear_y_56 = (delta_y_56 / 100) * gear_sensitivity_array[gear_sensitivity];

  delta_gear_change = (delta_gear_y_12 + delta_gear_y_34 + delta_gear_y_56) / 3;

//calculul palierului X curent:
  delta_gear_x = x_axis_pot.returnPotValue() - x_34;
  current_x_position = 2;

  if(x_12 < x_34)
  {
    if(delta_gear_x < 0 && (-1 * delta_gear_x) > x_delta_left)
    {
      current_x_position = 1;
    }

    if(delta_gear_x > 0 && delta_gear_x > x_delta_right)
    {
      current_x_position = 3;
    }
    
  }
    else
    {
      if(delta_gear_x > 0 && delta_gear_x > x_delta_left)
      {
        current_x_position = 1;
      }

      if(delta_gear_x < 0 && (-1 * delta_gear_x) > x_delta_right)
      {
        current_x_position = 3;
      }
    }
  
}

//refresh al LED-urilor la schimbari de stare a sistemului
if(sys_refresh == true && calibration_on == false)
{
  sys_refresh = false;

  if(h_shifter_on == true)
  {
    if(hold_button_for_gear == false)
    {
      gear_model_led.lightOn();
    }
      else
      {
        gear_model_led.lightOff();
      }

    if(gear_sensitivity == 0)
    {
       menu_led.lightOn();
    }
      else
      {
        menu_led.lightOff();
      }
  }
    else
    {
      if(current_seq_state == 0)
      {
        if(logitech_dfs_seq_amplitude_percentage == 0)
        {
          menu_led.lightOn();
        }
          else
          {
            menu_led.lightOff();
          }
      }
        else
        {
          menu_led.lightOff();
        }
    }
}




DIN_connector.virtualButtonRefreshState();

new_gear_shifter_disconnected = DIN_connector.virtualButtonState();//daca e true, schimbatorul de viteze este deconectat de la adaptor

if(new_gear_shifter_disconnected != gear_shifter_disconnected)
{
  gear_shifter_disconnected = new_gear_shifter_disconnected;
  if(gear_shifter_disconnected == true)
  {
    Joystick.releaseButton(0);
    Joystick.releaseButton(1);
    Joystick.releaseButton(2);
    Joystick.releaseButton(3);
    Joystick.releaseButton(4);
    Joystick.releaseButton(5);
    Joystick.releaseButton(6);
    Joystick.releaseButton(7);
    Joystick.releaseButton(8);
    Joystick.releaseButton(9);

    menu_led.lightOff();
    gear_model_led.lightOff();

  }
    else
    {
      if(seq_h_selector.on())
      {
        h_shifter_on = true;
      }
        else
        {
          h_shifter_on = false;
        }

      //read_from_eeprom = true;
      //sys_refresh = true;
      sys_start = true;
    }
}

if(seq_h_selector.pressed() && gear_shifter_disconnected == false)
{
    Joystick.releaseButton(0);
    Joystick.releaseButton(1);
    Joystick.releaseButton(2);
    Joystick.releaseButton(3);
    Joystick.releaseButton(4);
    Joystick.releaseButton(5);
    Joystick.releaseButton(6);
    Joystick.releaseButton(7);
    Joystick.releaseButton(8);
    Joystick.releaseButton(9);

    menu_led.lightOff();
    gear_model_led.lightOff();

    h_shifter_on = true;

    read_from_eeprom = true;
    sys_refresh = true;    
}

if(seq_h_selector.released() && gear_shifter_disconnected == false)
{
    Joystick.releaseButton(0);
    Joystick.releaseButton(1);
    Joystick.releaseButton(2);
    Joystick.releaseButton(3);
    Joystick.releaseButton(4);
    Joystick.releaseButton(5);
    Joystick.releaseButton(6);
    Joystick.releaseButton(7);
    Joystick.releaseButton(8);
    Joystick.releaseButton(9);

    menu_led.lightOff();
    gear_model_led.lightOff();

    h_shifter_on = false;

    read_from_eeprom = true;
    sys_refresh = true;    
}


if(gear_shifter_disconnected == false && h_shifter_on == true)
{
  menu_button.refreshState();
  gear_model_button.refreshState();
  rear_gear_button.refreshState();
  
  x_axis_pot.refreshPotState();
  y_axis_pot.refreshPotState();

  
  if(gear_model_button.released()){
    hold_button_for_gear = !hold_button_for_gear;
  
    if(hold_button_for_gear == true)
    {
      eeprom_hold_button_for_gear = 1;
      gear_model_led.lightOff();
    }
      else
      {
        eeprom_hold_button_for_gear = 0;
        gear_model_led.lightOn();
      }
  
    EEPROM.put(sizeof(gear_sensitivity) + sizeof(calibration_x_values_array) + sizeof(calibration_y_values_array), eeprom_hold_button_for_gear);  
  }
  
  

  
  
  if(calibration_on == true)
  {
    if(calibration_state == true)
    {
      if(menu_button.pressed())
      {
        calibration_x_values_array[calibration_current_gear - 1] = x_axis_pot.returnPotValue();
        calibration_y_values_array[calibration_current_gear - 1] = y_axis_pot.returnPotValue();
  
        if(calibration_current_gear != 6)
        {
          menu_led.blinkOff();
          menu_led.lightOn();        
          calibration_state = false;
        }
          else
          {
            calibration_current_gear = 1;
            menu_led.blinkOff();
            //scrie in memoria EEPROM cele doua array-uri de coordonate:
            EEPROM.put(sizeof(gear_sensitivity), calibration_x_values_array);
            EEPROM.put(sizeof(gear_sensitivity) + sizeof(calibration_x_values_array), calibration_y_values_array);
            calibration_state = false;
            calibration_on = false;
            if(gear_sensitivity == 0)
            {
              menu_led.lightOn();
            }
            read_from_eeprom == true;
          }
      }
    }
      else
      {
        int y_dist = 0;
        y_dist = y_axis_pot.returnPotValue() - calibration_y_values_array[calibration_current_gear - 1];
        y_dist = abs(y_dist);
        
        if(y_dist >= delta_gear_change / 2)
        {
          calibration_current_gear += 1;
          menu_led.blinkOn(250);
          calibration_state = true;
        }
      }
  }
    else
    {
      if(check_sensitivity_led == true)
      {
        check_sensitivity_led = false;
        if(gear_sensitivity == 0)
        {
          menu_led.lightOn();
        }
      }
      //verificare a folosirii butonului de menu - se face pe release deoarece se foloseste si apasarea indelungata
      if(menu_button.released())
      {
        if(menu_button.timedAction())//initiaza intrarea in calibrare la apasarea indelungata
        {
          calibration_on = true;
          calibration_state = true;
          menu_led.blinkOn(250);
        }
          else//trece la treapta urmatoare de sensibilitate a intrarii in viteza folosind wrap daca e la ultima din array(pozitia 5)
          {
            if(gear_sensitivity < 5)
            {
  
              if(gear_sensitivity == 0)
              {
                menu_led.lightOff();
              }
              gear_sensitivity = gear_sensitivity + 1;
              EEPROM.put(0, gear_sensitivity);
              delay(5);
              read_from_eeprom = true;
  
            }
              else
              {
                gear_sensitivity = 0;
                EEPROM.put(0, gear_sensitivity);
                delay(5);
                read_from_eeprom = true;
                menu_led.lightOn();
              }
          }
        
      }
      //functionarea normala a schimbatorului de viteze:
  
  //calculul palierului X curent:
    delta_gear_x = x_axis_pot.returnPotValue() - x_34;
    current_x_position = 2;
  
    if(x_12 < x_34)
    {
      if(delta_gear_x < 0 && (-1 * delta_gear_x) > x_delta_left)
      {
        current_x_position = 1;
      }
  
      if(delta_gear_x > 0 && delta_gear_x > x_delta_right)
      {
        current_x_position = 3;
      }
      
    }
      else
      {
        if(delta_gear_x > 0 && delta_gear_x > x_delta_left)
        {
          current_x_position = 1;
        }
  
        if(delta_gear_x < 0 && (-1 * delta_gear_x) > x_delta_right)
        {
          current_x_position = 3;
        }
      }
  
      switch(current_x_position)
      {
        case 1:
          delta_to_low_gear = y_axis_pot.returnPotValue() - y_1;
          if(abs(delta_to_low_gear) <= delta_gear_change && current_gear != 1)
          {
            if(hold_button_for_gear == false)
            {
              current_gear = 1;
              Joystick.pressButton(1);
              delay(gear_button_release_delay);
              Joystick.releaseButton(1);
            }
              else
              {
                if(current_gear != 0){Joystick.releaseButton(current_gear);}
                current_gear = 1;
                Joystick.pressButton(1);
              }
          }
  
          delta_to_high_gear = y_axis_pot.returnPotValue() - y_2;
          if(abs(delta_to_high_gear) <= delta_gear_change && current_gear != 2)
          {
            if(hold_button_for_gear == false)
            {
              current_gear = 2;
              Joystick.pressButton(2);
              delay(gear_button_release_delay);
              Joystick.releaseButton(2);
            }
              else
              {
                if(current_gear != 0){Joystick.releaseButton(current_gear);}
                current_gear = 2;
                Joystick.pressButton(2);
              }
          }
  
          if(abs(delta_to_low_gear) > delta_gear_change && abs(delta_to_high_gear) > delta_gear_change && current_gear != 0)
          {
            if(hold_button_for_gear == false)
            {
              current_gear = 0;
              Joystick.pressButton(0);
              delay(gear_button_release_delay);
              Joystick.releaseButton(0);
            }
              else
              {
                Joystick.releaseButton(current_gear);
                current_gear = 0;
              }
  
          }
  
          break;
          
        case 2:
          delta_to_low_gear = y_axis_pot.returnPotValue() - y_3;
          if(abs(delta_to_low_gear) <= delta_gear_change && current_gear != 3)
          {
            if(hold_button_for_gear == false)
            {
              current_gear = 3;
              Joystick.pressButton(3);
              delay(gear_button_release_delay);
              Joystick.releaseButton(3);
            }
              else
              {
                if(current_gear != 0){Joystick.releaseButton(current_gear);}
                current_gear = 3;
                Joystick.pressButton(3);
              }
          }
  
          delta_to_high_gear = y_axis_pot.returnPotValue() - y_4;
          if(abs(delta_to_high_gear) <= delta_gear_change && current_gear != 4)
          {
            if(hold_button_for_gear == false)
            {
              current_gear = 4;
              Joystick.pressButton(4);
              delay(gear_button_release_delay);
              Joystick.releaseButton(4);
            }
              else
              {
                if(current_gear != 0){Joystick.releaseButton(current_gear);}
                current_gear = 4;
                Joystick.pressButton(4);
              }          
          }
  
          if(abs(delta_to_low_gear) > delta_gear_change && abs(delta_to_high_gear) > delta_gear_change && current_gear != 0)
          {
            if(hold_button_for_gear == false)
            {
              current_gear = 0;
              Joystick.pressButton(0);
              delay(gear_button_release_delay);
              Joystick.releaseButton(0);
            }
              else
              {
                Joystick.releaseButton(current_gear);
                current_gear = 0;
              }          
          }
  
          break;
  
        case 3:
          delta_to_low_gear = y_axis_pot.returnPotValue() - y_5;
          if(abs(delta_to_low_gear) <= delta_gear_change && current_gear != 5)
          {
            if(hold_button_for_gear == false)
            {
              current_gear = 5;
              Joystick.pressButton(5);
              delay(gear_button_release_delay);
              Joystick.releaseButton(5);
            }
              else
              {
                if(current_gear != 0){Joystick.releaseButton(current_gear);}
                current_gear = 5;
                Joystick.pressButton(5);
              }        
          }
  
          delta_to_high_gear = y_axis_pot.returnPotValue() - y_6;
  
          switch(rear_gear_button.on())
          {
            case false:
              if(abs(delta_to_high_gear) <= delta_gear_change && current_gear != 6 && current_gear != 7)
              {
                if(hold_button_for_gear == false)
                {
                  current_gear = 6;
                  Joystick.pressButton(6);
                  delay(gear_button_release_delay);
                  Joystick.releaseButton(6);
                }
                  else
                  {
                    if(current_gear != 0){Joystick.releaseButton(current_gear);}
                    current_gear = 6;
                    Joystick.pressButton(6);
                  }        
              }
              break;
  
            case true:
              if(abs(delta_to_high_gear) <= delta_gear_change && current_gear != 7)
              {
                if(hold_button_for_gear == false)
                {
                  current_gear = 7;
                  Joystick.pressButton(7);
                  delay(gear_button_release_delay);
                  Joystick.releaseButton(7);                                          
                }
                  else
                  {
                    if(current_gear != 0){Joystick.releaseButton(current_gear);}
                    current_gear = 7;
                    Joystick.pressButton(7);                  
                  }
              }
              break;
          }
  
          if(abs(delta_to_low_gear) > delta_gear_change && abs(delta_to_high_gear) > delta_gear_change && current_gear != 0)
          {
            if(hold_button_for_gear == false)
            {
              current_gear = 0;
              Joystick.pressButton(0);
              delay(gear_button_release_delay);
              Joystick.releaseButton(0);
            }
              else
              {
                Joystick.releaseButton(current_gear);
                current_gear = 0;
              }          
          }
  
          break;
      }
    }
menu_led.blinkBeat();
}


if(gear_shifter_disconnected == false && h_shifter_on == false)
{

  gear_model_button.refreshState();
  menu_button.refreshState();


  if(gear_model_button.released())
  {
    if(gear_model_button.timedAction())
    {
      if(current_seq_state == 1)
      {
        handbrake_calibration_on = true;
        gear_model_led.blinkOn(250);
        low_handbrake_limit = x_neutral;
        high_handbrake_limit = x_neutral;       
      }
    }
      else
      {
        if(handbrake_calibration_on == true)
        {
          handbrake_calibration_on = false;
          gear_model_led.blinkOff();
          EEPROM.put(mem_size_h_var + sizeof(current_seq_state) + sizeof(logitech_dfs_seq_amplitude_percentage) + sizeof(logitech_dfs_seq_updown), low_handbrake_limit);
          EEPROM.put(mem_size_h_var + sizeof(current_seq_state) + sizeof(logitech_dfs_seq_amplitude_percentage) + sizeof(logitech_dfs_seq_updown)
                    + sizeof(low_handbrake_limit), high_handbrake_limit);
          low_handbrake_deadzone = (x_neutral - low_handbrake_limit) * handbrake_deadzone_percentage / 100;
          high_handbrake_deadzone = (high_handbrake_limit - x_neutral) * handbrake_deadzone_percentage / 100;
        }
          else
          {
            logitech_dfs_seq_updown = !logitech_dfs_seq_updown;
            EEPROM.put(mem_size_h_var + sizeof(current_seq_state) + sizeof(logitech_dfs_seq_amplitude_percentage), logitech_dfs_seq_updown);
          }
      }
  }
  if(menu_button.released())
  {
    if(menu_button.timedAction())
    {
      if(current_seq_state != 2)
      {
        current_seq_state = current_seq_state + 1;
        switch(current_seq_state)
        {
          case 1:
            gear_model_led.lightOn();
            delay(300);
            gear_model_led.lightOff();
            delay(400);
            gear_model_led.lightOn();
            delay(300);
            gear_model_led.lightOff();
            break;
          
          case 2:
            gear_model_led.lightOn();
            delay(300);
            gear_model_led.lightOff();
            delay(400);
            gear_model_led.lightOn();
            delay(300);
            gear_model_led.lightOff();
            delay(400);
            gear_model_led.lightOn();
            delay(300);
            gear_model_led.lightOff();
            break;
        }
      }
        else
        {
          current_seq_state = 0;
          gear_model_led.lightOn();
          delay(300);
          gear_model_led.lightOff();
        }
      EEPROM.put(mem_size_h_var, current_seq_state);
      Joystick.releaseButton(9);
      Joystick.releaseButton(8);
      sys_refresh = true;
    }
      else
      {
        if(current_seq_state == 0)
        {
          if(logitech_dfs_seq_amplitude_percentage != 2)
          {
            logitech_dfs_seq_amplitude_percentage = logitech_dfs_seq_amplitude_percentage + 1;
          }
            else
            {
              logitech_dfs_seq_amplitude_percentage = 0;
            }
      
          EEPROM.put(mem_size_h_var + sizeof(current_seq_state), logitech_dfs_seq_amplitude_percentage);
          delta_gear_to_neutral = (x_neutral * seq_gear_sensitivity_array[logitech_dfs_seq_amplitude_percentage]) / 100;
          sys_refresh = true;
        }
      }
  }

  switch(current_seq_state)
  {
    case 0://Logitech DFS as sequential shifter
      x_axis_pot.refreshPotState();
      x_position = x_axis_pot.returnPotValue();
  
      if(x_position > x_neutral - delta_gear_to_neutral && x_position < x_neutral + delta_gear_to_neutral)
      {
        if(logitech_dfs_seq_gear_up == true)
        {
          logitech_dfs_seq_gear_up = false;
          Joystick.releaseButton(9);
        }
    
        if(logitech_dfs_seq_gear_down == true)
        {
          logitech_dfs_seq_gear_down = false;
          Joystick.releaseButton(8);
        }
      }
  
      if(logitech_dfs_seq_updown == true)
      {
  
        if(x_position <= x_neutral - delta_gear_to_neutral && logitech_dfs_seq_gear_down == false)
        {
          logitech_dfs_seq_gear_down = true;
          Joystick.pressButton(8);       
        }
    
        if(x_position >= x_neutral + delta_gear_to_neutral && logitech_dfs_seq_gear_up == false)
        {
          logitech_dfs_seq_gear_up = true;
          Joystick.pressButton(9);
        }
  
      }
        else
        {
          if(x_position <= x_neutral - delta_gear_to_neutral && logitech_dfs_seq_gear_up == false)
          {
            logitech_dfs_seq_gear_up = true;
            Joystick.pressButton(9);          
          }
  
          if(x_position >= x_neutral + delta_gear_to_neutral && logitech_dfs_seq_gear_down == false)
          {
            logitech_dfs_seq_gear_down = true;
            Joystick.pressButton(8);                
          }
        }

      break;

    case 1://Logitech DFS as handbrake
      x_axis_pot.refreshPotState();
      x_position = x_axis_pot.returnPotValue();
      
      if(handbrake_calibration_on == true)
      {
        if(x_position < low_handbrake_limit)
        {
          low_handbrake_limit = x_position;
        }
        if(x_position > high_handbrake_limit)
        {
          high_handbrake_limit = x_position;
        }
      }
        else
        {
          if(logitech_dfs_seq_updown == true)
          {
            if(x_position > high_handbrake_limit)
            {
              x_position = high_handbrake_limit;
            }
            if(x_position >= x_neutral + high_handbrake_deadzone)
            {
              long x_position_long = x_position;
              long x_neutral_long = x_neutral;
              long high_handbrake_deadzone_long = high_handbrake_deadzone;
              long high_handbrake_limit_long = high_handbrake_limit;
              handbrake_axis_value = 255 * (x_position_long - x_neutral_long - high_handbrake_deadzone_long) / (high_handbrake_limit_long - x_neutral_long - high_handbrake_deadzone_long);
            }
              else
              {
                handbrake_axis_value = 0;
              }
            Joystick.setRudder(handbrake_axis_value);
          }
            else
            {
              if(x_position < low_handbrake_limit)
              {
                x_position = low_handbrake_limit;
              }
              if(x_position <= x_neutral - low_handbrake_deadzone)
              {
                long x_position_long = x_position;
                long x_neutral_long = x_neutral;
                long low_handbrake_deadzone_long = low_handbrake_deadzone;
                long low_handbrake_limit_long = low_handbrake_limit;                
                handbrake_axis_value = 255 * (x_neutral_long - low_handbrake_deadzone_long - x_position_long) / (x_neutral_long - low_handbrake_deadzone_long - low_handbrake_limit_long);
              }
                else
                {
                  handbrake_axis_value = 0;
                }
              Joystick.setRudder(handbrake_axis_value);
            }
        }
      break;


    case 2://generic sequential shifter based on microswitches
      gear_down_button.refreshState();
      gear_up_button.refreshState();

      if(logitech_dfs_seq_updown == true)
      {
        if(gear_down_button.pressed())
        {
          Joystick.pressButton(8);
        }
        if(gear_down_button.released())
        {
          Joystick.releaseButton(8);
        }
      
        if(gear_up_button.pressed())
        {
          Joystick.pressButton(9);
        }
        if(gear_up_button.released())
        {
          Joystick.releaseButton(9);
        }
      }
        else
        {
          if(gear_down_button.pressed())
          {
            Joystick.pressButton(9);
          }
          if(gear_down_button.released())
          {
            Joystick.releaseButton(9);
          }
        
          if(gear_up_button.pressed())
          {
            Joystick.pressButton(8);
          }
          if(gear_up_button.released())
          {
            Joystick.releaseButton(8);
          }          
        }
        
      break;
  }
gear_model_led.blinkBeat();  
}
/*
Serial.print(delta_gear_to_neutral);
Serial.print(" ");
Serial.print(logitech_dfs_seq);
Serial.print(" ");
Serial.print(logitech_dfs_seq_updown);
Serial.print(" ");
Serial.print(logitech_dfs_seq_gear_up);
Serial.print(" ");
Serial.println(logitech_dfs_seq_gear_down);
Serial.print(seq_h_selector.on());

Serial.print(x_12);
Serial.print(" ");
Serial.print(x_56);
Serial.print(" ");

Serial.print(x_neutral);
Serial.print(" ");
Serial.print(low_handbrake_limit);
Serial.print(" ");
Serial.print(high_handbrake_limit);
Serial.print(" ");
Serial.print(low_handbrake_deadzone);
Serial.print(" ");
Serial.print(high_handbrake_deadzone);
Serial.print(" ");
Serial.print(handbrake_axis_value);
Serial.print(" ");
Serial.println(x_position);
delay(1);


//menu_led.blinkBeat();
*/
}
